/*******************************************************************************
 *     Tablexia
 *
 *     Copyright (C) 2013  CZ NIC z.s.p.o. <podpora at nic dot cz>
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/

package cz.nic.tablexia.game.trophy;

import java.util.ArrayList;
import java.util.List;

import cz.nic.tablexia.game.difficulty.GameDifficulty;

/**
 * Definitions of user trophies
 *
 * @author Matyáš Latner
 */
public enum UserTrophyDefinition implements TrophyEnum {

    CONSECUTIVELY_DAYSBACK_3(UserTrophyTypeDefinition.CONSECUTIVELY_DAYSBACK, "consecutively3Days", "trophy_user_consecutively3days", "trophy_user_consecutively3days_description", 3),
    CONSECUTIVELY_DAYSBACK_5(UserTrophyTypeDefinition.CONSECUTIVELY_DAYSBACK, "consecutively5Days", "trophy_user_consecutively5days", "trophy_user_consecutively5days_description", 5),
    CONSECUTIVELY_DAYSBACK_8(UserTrophyTypeDefinition.CONSECUTIVELY_DAYSBACK, "consecutively8Days", "trophy_user_consecutively8days", "trophy_user_consecutively8days_description", 8),
    ONEDAYALLGAMES_0STARS(UserTrophyTypeDefinition.ONEDAYALLGAMES, "consecutivelyAllGames0Stars", "trophy_user_consecutivelyallgames0stars", "trophy_user_consecutivelyallgames0stars_description", 0),
    CONSECUTIVELYALLGAMES_MEDIUMDIFFICULTY(UserTrophyTypeDefinition.CONSECUTIVELY_ALLGAMES, "consecutivelyAllGames2Stars", "trophy_user_consecutivelyallgames2stars", "trophy_user_consecutivelyallgames2stars_description", GameDifficulty.MEDIUM.ordinal()),
    CONSECUTIVELYALLGAMES_HARDDIFFICULTY(UserTrophyTypeDefinition.CONSECUTIVELY_ALLGAMES, "consecutivelyAllGames3Stars", "trophy_user_consecutivelyallgames3stars", "trophy_user_consecutivelyallgames2stars_description", GameDifficulty.HARD.ordinal());

    private UserTrophyTypeDefinition trophyTypeDefinition;
    private String                   dbFieldName;
    private String                   imageName;
    private String                   imageDescription;
    private int                      limit;

    private UserTrophyDefinition(UserTrophyTypeDefinition trophyTypeDefinition, String dbFieldName, String imageName, String imageDescription, int limit) {

        this.trophyTypeDefinition = trophyTypeDefinition;
        this.dbFieldName = dbFieldName;
        this.imageName = imageName;
        this.imageDescription = imageDescription;
        this.limit = limit;
    }

    public UserTrophyTypeDefinition getTrophyTypeDefinition() {
        return trophyTypeDefinition;
    }

    public String getDbFieldName() {
        return dbFieldName;
    }

    @Override
    public String getTrophyName() {
        return null;
    }

    @Override
    public String getTrophyDescription() {
        return null;
    }

    public int getLimit() {
        return limit;
    }

 //   public static List<TrophyEnum> processUserTrophies(User user) {
//        List<TrophyEnum> resultList = new ArrayList<TrophyEnum>();
//        for (UserTrophyDefinition userTrophyDefinition : UserTrophyDefinition.getTrophyDefinitionByUserTrophyDefinition(UserTrophyTypeDefinition.CONSECUTIVELY_DAYSBACK)) {
//            if (!Utility.isSetTrophyForName(user, userTrophyDefinition.getDbFieldName())) {
//                boolean result = true;
//                for (int i = 0; i < userTrophyDefinition.getLimit(); i++) {
//                    boolean existGame = GameManager.isGameManagerForDayBack(user.getId(), i);
//                    result = result && existGame;
//                    if (!existGame) {
//                        break;
//                    }
//                }
//                if (result) {
//                    Utility.setTrophyForName(user, userTrophyDefinition.getDbFieldName());
//                    resultList.add(userTrophyDefinition);
//                }
//            }
//        }
//
//        for (UserTrophyDefinition userTrophyDefinition : UserTrophyDefinition.getTrophyDefinitionByUserTrophyDefinition(UserTrophyTypeDefinition.ONEDAYALLGAMES)) {
//            if (!Utility.isSetTrophyForName(user, userTrophyDefinition.getDbFieldName())) {
//                if (GameManager.existsGameTypeManagersInOneDayWithStars(user.getId(), userTrophyDefinition.getLimit())) {
//                    Utility.setTrophyForName(user, userTrophyDefinition.getDbFieldName());
//                    resultList.add(userTrophyDefinition);
//                }
//            }
//        }
//
//        for (UserTrophyDefinition userTrophyDefinition : UserTrophyDefinition.getTrophyDefinitionByUserTrophyDefinition(UserTrophyTypeDefinition.CONSECUTIVELY_ALLGAMES)) {
//            if (!Utility.isSetTrophyForName(user, userTrophyDefinition.getDbFieldName())) {
//                if (GameManager.existsGameTypeManagersConsecutivelyWithStarsNumberAndDifficulty(user.getId(), userTrophyDefinition.getLimit(), 3)) {
//                    Utility.setTrophyForName(user, userTrophyDefinition.getDbFieldName());
//                    resultList.add(userTrophyDefinition);
//                }
//            }
//        }
//
//        user.save();
//        return resultList;
 //   }

    public static List<UserTrophyDefinition> getTrophyDefinitionByUserTrophyDefinition(UserTrophyTypeDefinition trophyTypeDefinition) {
        List<UserTrophyDefinition> result = new ArrayList<UserTrophyDefinition>();
        for (UserTrophyDefinition trophyDefinition : UserTrophyDefinition.values()) {
            if (trophyDefinition.getTrophyTypeDefinition() == trophyTypeDefinition) {
                result.add(trophyDefinition);
            }
        }
        return result;
    }

}
