package cz.nic.tablexia.loader.application;

import cz.nic.tablexia.loader.IApplicationLoader;
import cz.nic.tablexia.loader.TablexiaSoundManager;


public class ApplicationSoundManager extends TablexiaSoundManager implements IApplicationLoader {

	private static ApplicationSoundManager instance;

	private ApplicationSoundManager() {
        super(StorageType.EXTERNAL);
    }
	
	public static ApplicationSoundManager getInstance() {
		if (instance == null) {
			instance = new ApplicationSoundManager();
		}
		return instance;
	}
	
	@Override
	public synchronized void dispose() {
		super.dispose();
		instance = null;
	}

	private	static final String APPLICATION_PATH				= "application/";
	
	private static final String MAINMENU_PATH 					= APPLICATION_PATH + "mainmenu/";
	public 	static final String MAINMENU_OPEN				    = MAINMENU_PATH + "mainmenu_open.mp3";
    public 	static final String MAINMENU_CLOSE				    = MAINMENU_PATH + "mainmenu_close.mp3";

    public void load() {
        loadSound(MAINMENU_OPEN);
        loadSound(MAINMENU_CLOSE);
    }
}