package cz.nic.tablexia.loader.application;

import cz.nic.tablexia.loader.IApplicationLoader;
import cz.nic.tablexia.loader.TablexiaTextureManager;


public class ApplicationTextureManager extends TablexiaTextureManager implements IApplicationLoader {
	
	private static ApplicationTextureManager instance;
	
	private ApplicationTextureManager() {
        super(StorageType.EXTERNAL);
    }
	
	public static ApplicationTextureManager getInstance() {
		if (instance == null) {
			instance = new ApplicationTextureManager();
		}
		return instance;
	}
	
	@Override
	public synchronized void dispose() {
		super.dispose();
		instance = null;
	}

    public static final class UniversalAssets {
        public static final String BACKGROUND_WOODEN = "universal/background_wooden.png";
    }

	private	static final String APPLICATION_PATH				= "application/";
	
	private static final String MAINMENU_PATH 					= APPLICATION_PATH + "mainmenu/";
	public 	static final String MAINMENU_BACKGROUND				= MAINMENU_PATH + "background.png";
	
	public void load() {
        loadTexture(MAINMENU_BACKGROUND);
    }
}