package cz.nic.tablexia.menu;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.Actor;

import cz.nic.tablexia.graphics.ColorTexture;

/**
 * MainMenu dimmer
 *
 * @author Matyáš Latner
 */
public class MainMenuDimmer extends Actor {

    private static final float      MAIN_MENU_DIMMER_MAX_ALPHA   = 0.7f;
    public static final Color       DIMMER_COLOR = Color.BLACK;

    private final Texture           texture;

    public MainMenuDimmer(float width, float height) {
        setBounds(0, 0, width, height);
        texture = new ColorTexture((int)width, (int)height, DIMMER_COLOR);
    }

    @Override
    public void draw(Batch batch, float parentAlpha) {
        Color color = getColor();
        color.a = color.a * MAIN_MENU_DIMMER_MAX_ALPHA;

        batch.setColor(getColor());
        batch.draw(texture, 0, 0);
        batch.setColor(Color.WHITE);
    }
}
