package cz.nic.tablexia.screen.createuser;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;

import java.util.List;

import cz.nic.tablexia.screen.AbstractTablexiaScreen;

/**
 * Screen showing street animation and office before user create form
 */
public class PanoramaScreen extends AbstractTablexiaScreen<Void> {
    private PanoramaAssets assets = new PanoramaAssets();

    private Actor balconyBlur, newspaper, newspaperOpen;

    @Override
    protected void prepareScreenTextureAssetNames(List<String> textureFileNames) {
        super.prepareScreenTextureAssetNames(textureFileNames);
        textureFileNames.addAll(assets.values());
    }

    @Override
    protected void screenLoaded() {
        switchScreen(prepareBalcony());
    }

    private void switchScreen(Actor actor) {
        getStage().clear();
        getStage().addActor(actor);
    }

    private Actor prepareBalcony() {
        Group group = new Group();

        boolean isWinter = true;

        Image balcony = new Image(getTexture(assets.get("balcony" + (isWinter ? "_winter" : ""))));
        setFullScreen(balcony);
        group.addActor(balcony);

        balconyBlur = new Image(getTexture(assets.get("balcony_blur" + (isWinter ? "_winter" : ""))));
        setFullScreen(balconyBlur);
        group.addActor(balconyBlur);

        // TODO newspaper spin
        // TODO newspaper detail

        setFullScreen(group);
        return group;
    }

    private Actor prepareSwipeStreet() {
        Group group = new Group();
        // TODO tiles in horizontal panel
        // TODO active door

        setFullScreen(group);
        return group;
    }

    private Actor prepareOffice() {
        Group group = new Group();

        Image background = new Image(getTexture(assets.get("detectiveoffice")));
        setFullScreen(background);
        group.addActor(background);

        setFullScreen(group);
        return group;
    }

    private void setFullScreen(Actor actor) {
        actor.setPosition(0, 0);
        actor.setSize(getStage().getWidth(), getStage().getHeight());
    }
}
