package cz.nic.tablexia.util.ui.dialog;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.ui.Label;

import cz.nic.tablexia.loader.application.ApplicationFontManager;
import cz.nic.tablexia.util.ui.dialog.text.DialogTextContent;

/**
 * Created by Václav Tarantík on 24.4.15.
 */
public class TextDialog extends TablexiaDialog {
    private static final float TITLE_FONT_SCALE = 0.7f;
    private static final float CONTENT_FONT_SCALE = 0.5f;
    private DialogTextContent dialogTextContent;

    public TextDialog(float x, float y, float width, float height, BackGroundType backGroundType, DialogTextContent dialogTextContent) {
        super(x, y, width, height, backGroundType);
        this.dialogTextContent = dialogTextContent;
    }

    @Override
    protected void prepareContent() {
        Label.LabelStyle titleLabelStyle = new Label.LabelStyle(ApplicationFontManager.getInstance().getFont(ApplicationFontManager.APPLICATION_DEFAULT_FONT_BOLD), Color.BLACK);
        // TODO fix scaling
        //titleLabelStyle.font.setScale(TITLE_FONT_SCALE);
        if(dialogTextContent.getTitle() != null && !dialogTextContent.getTitle().equals("")){
            Label titleLabel = new Label(dialogTextContent.getTitle(),titleLabelStyle);
            getContentTable().add(titleLabel).center()  ;
            getContentTable().row();
        }
        Label.LabelStyle contentLabelStyle = new Label.LabelStyle(ApplicationFontManager.getInstance().getFont(ApplicationFontManager.APPLICATION_DEFAULT_FONT_REGULAR), Color.BLACK);
        // TODO fix scaling
        //contentLabelStyle.font.setScale(CONTENT_FONT_SCALE);
        Label label = new Label(dialogTextContent.getContent(),contentLabelStyle);
        label.setWrap(true);
        getContentTable().add(label).left().top().expand().fillX();
    }
}
