package cz.nic.tablexia.util.ui.dialog;

import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;

import cz.nic.tablexia.util.ui.dialog.text.DialogTextContent;

/**
 * Created by Václav Tarantík on 26.3.15.
 */
public abstract class TwoButtonDialog extends AbstractButtonDialog {
    private ButtonType leftButtonType;
    private  ButtonType rightButtonType;
    private String leftButtonText;
    private String rightButtonText;

    public TwoButtonDialog(float x, float y, float width, float height, BackGroundType backGroundType,DialogTextContent dialogTextContent, ButtonType leftButtonType, ButtonType rightButtonType,String leftButtonText, String rightButtonText) {
        super(x, y, width, height, backGroundType, dialogTextContent);
        this.leftButtonType = leftButtonType;
        this.rightButtonType = rightButtonType;
        this.leftButtonText = leftButtonText;
        this.rightButtonText = rightButtonText;
    }

    @Override
    protected void prepareContent() {
        super.prepareContent();
        createButton(leftButtonType, leftButtonText, new ClickListener() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                leftButtonAction();
            }

            ;
        });

        createButton(rightButtonType,rightButtonText,new ClickListener() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                rightButtonAction();
            };
        });
    }

    protected abstract void leftButtonAction();
    protected abstract void rightButtonAction();
}
